<?php
error_reporting(E_ALL ^ (E_NOTICE | E_WARNING));
header("Content-type: text/plain");
@set_time_limit(0);
/*
name - database name
host - database hosting
port - database hosting port
user - database user name
pass - database user password
action 
	- db_list
	- table_list
	- create_table
	- data
	- execute
db_exc - escape quote

*/
function error($error){
	@header("HTTP/1.1: 500 " . $error);
	@header("Status: 500 " . $error);
	die("ERROR: ".$error);
}

function query($q){
	$result=@mysql_query($q);
	if(mysql_errno()==0)
		return $result;
	else
	{
		error('MySQL: Error in '.$GLOBALS['SCRIPT_NAME']."\r\n\r\nQuery :\r\n".$q."\r\n\r\nResult :\r\n".mysql_error());
	}
}

function format($val){
	$val=str_replace("\\","\\\\",$val);
	$val=str_replace("'","\\'",$val);
	$val=str_replace("\n","\\n",$val);
	$val=str_replace("\r","\\r",$val);
	$val=str_replace("\x00","\\0",$val);
	$val=str_replace("\x1a","\\Z",$val);
	return $val;
}

if (empty($_GET) && empty($_POST)) error('empty param list');

function quote($var){
	if(!empty($_GET['db_esc']) || !empty($_POST['db_esc'])){
	$db_esc_q = !empty($_GET['db_esc']) ? $_GET['db_esc']:$_POST['db_esc'];
	}else $db_esc_q ='`';
	return $db_esc_q.$var.$db_esc_q;
}	

$db_name = !empty( $_GET['name'] ) ? $_GET['name'] : $_POST['name'];
$db_host = !empty( $_GET['host'] ) ? $_GET['host'] : $_POST['host'];
$db_port = !empty( $_GET['port'] ) ? $_GET['port'] : $_POST['port'];
$db_user = !empty( $_GET['user'] ) ? $_GET['user'] : $_POST['user'];
$db_pass = !empty( $_GET['pass'] ) ? $_GET['pass'] : $_POST['pass'];

if (isset($_GET['encrypt']) || isset($_POST['encrypt'])){
	$crypt = !empty ($_GET['encrypt']) ? $_GET['encrypt']: $_POST['encrypt'];
	switch ($crypt){
		case 1: 
			$db_user = base64_decode ( $db_user );
			$db_pass = base64_decode ( $db_pass );
		break;
	}
}

$db_host .= empty($db_host) ? 'localhost' : '';

if (empty($db_user)) 
	error('not entered all required parameters');

$db_host .= !empty($db_port ) ? ':'.$db_port:''; 

$db_link = @mysql_connect($db_host,$db_user,$db_pass);

if(!$db_link) error('MySQL: Could not connect to MySQL Server');
	
if ($db_name){
	$status = @mysql_select_db($db_name);
	if (!$status){
		error('MySQL: Could not select database : ' . $db_name);
	}
	unset($status);
}

$action = !empty($_GET['action']) ? $_GET['action']:$_POST['action'];
switch ($action) 
{
	case 'db_list': 
			$res=query("show databases");
			while ($arr=mysql_fetch_array($res,MYSQL_NUM)){
				echo $arr[0]."\r\n";
			}
		break;
	case 'table_list':
			$res=query("show tables from ".quote($db_name)."");
			while($arr=mysql_fetch_array($res,MYSQL_NUM)){
				echo $arr[0]."\r\n";
			}
		break;
	case 'create_table':
			$table = !empty($_GET['table']) ? $_GET['table'] : $_POST['table'];
			if (empty($table)) {
				error('PHP: table name is empty ');
			}
			else {
				$c=mysql_fetch_row(query("show create table ".quote($table).""));
				$c = str_replace('CREATE TABLE','CREATE TABLE IF NOT EXISTS',$c);
				echo $c[1].";\r\n";
			}	
		break;
	case 'create_db': 
   			$c=mysql_fetch_row(query("SHOW CREATE DATABASE ".quote($db_name).""));
			$c = str_replace('CREATE DATABASE','CREATE DATABASE IF NOT EXISTS',$c);
			echo $c[1].";\r\n"; 
  		break;
	
	case 'data':
			$table = !empty($_GET['table']) ? $_GET['table'] : $_POST['table'];
			if (empty($table)) {
				error('PHP: table name is empty ');
			}
			else {
		
				$res=query("select * from ".quote($table)."");
				$n=mysql_num_fields($res);

				$field_list='';
				for($i=0;$i<$n;$i++)
					$field_list.="".quote(mysql_field_name($res,$i)).', ';
				//echo "INSERT INTO ".quote($table)." ( ".substr($field_list,0,-2)." ) values \r\n";
				//echo "insert into ".quote($table)." ( ".substr($field_list,0,-2)." ) values \r\n";

				while($r=mysql_fetch_row($res))	{
					//echo "INSERT INTO ".quote($table)." ( ".substr($field_list,0,-2)." ) values \r\n";
					echo "INSERT INTO ".quote($table)." VALUES ";
					echo "( ";
					for($k=0;$k<($n-1);$k++)
					{
						if (!is_null($r[$k])) echo "'".format($r[$k])."', ";
						else echo "NULL, ";
					}
					if (!is_null($r[$k])) echo "'".format($r[$k])."');\r\n";
						else echo "NULL);\r\n";
					}
			}
		break;
	case 'execute':
			$data = (isset($_GET['query']) ? $_GET['query'] : $_POST['query']);
			$only_lines = ($_GET['only_lines'] ? $_GET['only_lines'] : $_POST['only_lines']);

			if(get_magic_quotes_gpc()) $data=stripslashes($data);

			$queries = array();

			if ($only_lines == "1")
				$queries = explode("\r\n", $data);
			else
				$queries = query_parser($data);
				$n=count($queries);

				for($i=0; $i<$n; $i++){
					if ($only_lines == "1"){
						$queries[$i] = trim($queries[$i]);
						if ($queries[$i][0] == '#') continue;
						if (($queries[$i][0] == '-') || ($queries[$i][1] == '-')) continue;
						if (strlen($queries[$i])<1) continue;
					}
					$res=query($queries[$i]);
					echo mysql_affected_rows()."\r\n\r\n";
				}
		break;
	default: error('PHP: request action not found');
}

function query_parser($q){
	$n=strlen($q);
	$k=0;
	$queries=array();
	$current_delimiter='';

	for($i=0;$i<$n;$i++){
		// if this slash escapes something, current delimiter must not be affected
		if($q[$i]=='\\' && ($q[$i+1]=='\\' || $q[$i+1]=="'" || $q[$i+1]=='"')){
				$queries[$k] .= $q[$i].$q[$i+1];
				$i++;
		}
		// strip line comments : -- and #
		elseif($current_delimiter=='' && (($q[$i]=='-' && $q[$i+1]=='-') || $q[$i]=='#')){
			$x=@strpos($q,"\n",$i);
			if(!$x) $x=$n;
			$q=substr($q,0,$i).substr($q,$x);
			$n=strlen($q);
		}
		// strip in-line comments /* .... */
		elseif($current_delimiter=='' && $q[$i]=='/' && $q[$i+1]=='*'){
			$x=@strpos($q,"*/",$i);
			if(!$x) $x=$n;
			$q=substr($q,0,$i).substr($q,$x+1);
			$n=strlen($q);
		}
		else{
			if($q[$i]==$current_delimiter)
				$current_delimiter='';
			elseif($current_delimiter=='' && ($q[$i]=='`' || $q[$i]=="'" || $q[$i]=='"'))
				$current_delimiter=$q[$i];

			if($q[$i]==';' && $current_delimiter==''){
				$queries[$k] = trim($queries[$k]); // this is the end of the query
				if(trim(substr($q,$i),"\r \n;")!='')
					$k++;
			}
			else
				$queries[$k] .= $q[$i];
		}
	}
	$queries[$k]=trim($queries[$k]); // trim the last query
	if($queries[$k]=='') $queries=array_slice($queries,0,-1);
	return $queries;
}
//end script
mysql_close($db_link);
exit;
?>